---
name: "Bug Report"
about: "NERDTree is misbehaving? Tell us about it."
labels: bug
---
<!-- Attention! Please Read!

Please fill out ALL the information below so that the issue can be fully understood. Omitting
information will delay the resolution of your issue. It will be labeled "Needs More Info", and
may be closed until there is enough information.

Keep in mind that others may have the same question in the future. The better your information,
the more likely they'll be able to help themselves.
-->

#### Self-Diagnosis
Before creating an issue, take some time to search these resources for an answer. It's possible that someone else has already seen and solved your issue.
- [old NERDTree issues](https://github.com/preservim/nerdtree/issues?q=is%3Aissue)
- NERDTree documentation - `:h NERDTree`
- [NERDTree Wiki](https://github.com/preservim/nerdtree/wiki)
- Other resources: <https://stackoverflow.com>, <https://vi.stackexchange.com>, etc.

#### Environment
- Operating System: 
- Vim/Neovim version `:version`: 
- NERDTree version, found on first line of quickhelp `?`: 
- Are you using any of these NERDTree-dependent plugins?  <!-- Check the boxes after creating the issue. -->
    - [ ] [Xuyuanp/nerdtree-git-plugin](https://github.com/Xuyuanp/nerdtree-git-plugin)
    - [ ] [ryanoasis/vim-devicons](https://github.com/ryanoasis/vim-devicons)
    - [ ] [tiagofumo/vim-nerdtree-syntax-highlight](https://github.com/tiagofumo/vim-nerdtree-syntax-highlight)
    - [ ] [scrooloose/nerdtree-project-plugin](https://github.com/scrooloose/nerdtree-project-plugin)
    - [ ] [PhilRunninger/nerdtree-buffer-ops](https://github.com/PhilRunninger/nerdtree-buffer-ops)
    - [ ] [PhilRunninger/nerdtree-visual-selection](https://github.com/PhilRunninger/nerdtree-visual-selection)
    - [ ] [jistr/vim-nerdtree-tabs](https://github.com/jistr/vim-nerdtree-tabs)
    - [ ] Others (specify):
- Provide a minimal **.vimrc** file that will reproduce the issue.
```vim
```

#### Steps to Reproduce the Issue
1. 

#### Current Behavior (Include screenshots where appropriate.)

#### Expected Result

